# TD 1 : Hands-On Reinforcement Learning

MSO 3.4 Apprentissage Automatique

# 


## REINFORCE

The REINFORCE algorithm (also known as Vanilla Policy Gradient) is a policy gradient method that optimizes the policy directly using gradient descent. The following is the pseudocode of the REINFORCE algorithm:


> 🛠 **To be handed in**
> Use PyTorch to implement REINFORCE and solve the CartPole environement. Share the code in `reinforce_cartpole.py`, and share a plot showing the total reward accross episodes in the `README.md`. Also, share a file `reinforce_cartpole.pth` containing the learned weights. For saving and loading PyTorch models, check [this tutorial](https://pytorch.org/tutorials/beginner/saving_loading_models.html#saving-loading-model-for-inference)
![](reinforce_cartpole_dr_0.5.png)


## Model Evaluation

Now that you have trained your model, it is time to evaluate its performance. Run it with rendering for a few trials and see if the policy is capable of completing the task.

> 🛠 **To be handed in**
> Implement a script which loads your saved model and use it to solve the cartpole enviroment. Run 100 evaluations and share the final success rate across all evaluations in the `README.md`. Share the code in `evaluate_reinforce_cartpole.py`.

Remark: To me it was not clear what "Success rate" in this context means (Therefore i made some assumptions!). The openai gym wiki says that the environment is solved when the average is over 100 trials is greater than 195. To translate this into a successrate i assumed that it is just necessary to count how often out of 100 trials, the summed reward was bigger than 195.

From the evaluation script i used the success rate is 1.0 when we allow the maximum number of steps the environment offers.

## Familiarization with a complete RL pipeline: Application to training a robotic arm

Stable-Baselines3 (SB3) is a high-level RL library that provides various algorithms and integrated tools to easily train and test reinforcement learning models.

> 🛠 **To be handed in**
> Store the code in `a2c_sb3_cartpole.py`. Unless otherwise stated, you'll work upon this file for the next sections.

> 🛠 **To be handed in**
> Link the trained model in the `README.md` file.

🛠 Share the link of the wandb run in the `README.md` file.

wandb: https://wandb.ai/lennartecl-centrale-lyon/sb3?nw=nwuserlennartecl

huggingface: https://huggingface.co/lennartoe/Cartpole-v1/tree/main

### Full workflow with panda-gym

[Panda-gym](https://github.com/qgallouedec/panda-gym) is a collection of environments for robotic simulation and control. It provides a range of challenges for training robotic agents in a simulated environment. In this section, you will get familiar with one of the environments provided by panda-gym, the `PandaReachJointsDense-v3`. The objective is to learn how to reach any point in 3D space by directly controlling the robot's articulations.

> 🛠 **To be handed in**
> Share all the code in `a2c_sb3_panda_reach.py`. Share the link of the wandb run and the trained model in the `README.md` file.

wandb: https://wandb.ai/lennartecl-centrale-lyon/pandasgym_sb3?nw=nwuserlennartecl

huggingface: https://huggingface.co/lennartoe/PandaReachJointsDense-v3/tree/main

